--- old/usr/src/cmd/file/elf_read.c	2019-02-24 19:19:04.913351284 +0000
+++ new/usr/src/cmd/file/elf_read.c	2019-02-24 19:19:04.928289878 +0000
@@ -19,7 +19,7 @@
  * CDDL HEADER END
  */
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
-/*	  All Rights Reserved  	*/
+/*	  All Rights Reserved	*/
 
 
 /*	Copyright (c) 1987, 1988 Microsoft Corporation	*/
@@ -79,6 +79,7 @@
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <sys/elf.h>
+#include <sys/link.h>
 #include <elfcap.h>
 #include "file.h"
 #include "elf_read.h"
@@ -125,7 +126,7 @@
 
 /*
  * file_xlatetom:	translate different headers from file
- * 			representation to memory representaion.
+ *			representation to memory representaion.
  */
 #define	HDRSZ 512
 static int
@@ -141,7 +142,7 @@
 	/* will convert only these types */
 	if (type != ELF_T_EHDR && type != ELF_T_PHDR &&
 	    type != ELF_T_SHDR && type != ELF_T_WORD &&
-	    type != ELF_T_CAP)
+	    type != ELF_T_CAP && type != ELF_T_DYN)
 		return (ELF_READ_FAIL);
 
 	src.d_buf = (Elf_Void *)hdr;
@@ -162,7 +163,7 @@
 
 /*
  * xlatetom_nhdr:	There is no routine to convert Note header
- * 			so we convert each field of this header.
+ *			so we convert each field of this header.
  */
 static int
 xlatetom_nhdr(Elf_Nhdr *nhdr)
@@ -177,7 +178,7 @@
 
 /*
  * elf_read:	reads elf header, program, section headers to
- * 		collect all information needed for file(1)
+ *		collect all information needed for file(1)
  *		output and stores them in Elf_Info.
  */
 int
@@ -300,7 +301,7 @@
 /*
  * process_phdr:	Read Program Headers and see if it is a core
  *			file of either new or (pre-restructured /proc)
- * 			type, read the name of the file that dumped this
+ *			type, read the name of the file that dumped this
  *			core, else see if this is a dynamically linked.
  */
 static int
@@ -415,17 +416,12 @@
 static int
 process_shdr(Elf_Info *EI)
 {
-	int 		capn, mac;
-	int 		i, j, idx;
-	FILE_ELF_OFF_T	cap_off;
-	FILE_ELF_SIZE_T	csize;
+	int		mac;
+	int		i, j, idx;
 	char		*strtab;
 	size_t		strtab_sz;
-	Elf_Cap 	Chdr;
 	Elf_Shdr	*shdr = &EI_Shdr;
 
-
-	csize = sizeof (Elf_Cap);
 	mac = EI_Ehdr.e_machine;
 
 	/* if there are no sections, return success anyway */
@@ -457,9 +453,15 @@
 			continue;
 		}
 
-		cap_off = shdr->sh_offset;
 		if (shdr->sh_type == SHT_SUNW_cap) {
-			char capstr[128];
+			char		capstr[128];
+			Elf_Cap		Chdr;
+			FILE_ELF_OFF_T	cap_off;
+			FILE_ELF_SIZE_T	csize;
+			int capn;
+
+			cap_off = shdr->sh_offset;
+			csize = sizeof (Elf_Cap);
 
 			if (shdr->sh_size == 0 || shdr->sh_entsize == 0) {
 				(void) fprintf(stderr, ELF_ERR_ELFCAP1,
@@ -471,8 +473,8 @@
 				/*
 				 * read cap and xlate the values
 				 */
-				if (pread64(EI->elffd, &Chdr, csize, cap_off)
-				    != csize ||
+				if ((pread64(EI->elffd, &Chdr, csize, cap_off)
+				    != csize) ||
 				    file_xlatetom(ELF_T_CAP, (char *)&Chdr)
 				    == 0) {
 					(void) fprintf(stderr, ELF_ERR_ELFCAP2,
@@ -503,6 +505,39 @@
 				(void) strlcat(EI->cap_str, capstr,
 				    sizeof (EI->cap_str));
 			}
+		} else if (shdr->sh_type == SHT_DYNAMIC) {
+			Elf_Dyn dyn;
+			FILE_ELF_SIZE_T dsize;
+			FILE_ELF_OFF_T doff;
+			int dynn;
+
+			doff = shdr->sh_offset;
+			dsize = sizeof (Elf_Dyn);
+
+			if (shdr->sh_size == 0 || shdr->sh_entsize == 0) {
+				(void) fprintf(stderr, ELF_ERR_DYNAMIC1,
+				    File, EI->file);
+				return (ELF_READ_FAIL);
+			}
+
+			dynn = (shdr->sh_size / shdr->sh_entsize);
+			for (j = 0; j < dynn; j++) {
+				if (pread64(EI->elffd, &dyn, dsize, doff)
+				    != dsize ||
+				    file_xlatetom(ELF_T_DYN, (char *)&dyn)
+				    == 0) {
+					(void) fprintf(stderr, ELF_ERR_DYNAMIC2,
+					    File, EI->file);
+					return (ELF_READ_FAIL);
+				}
+
+				doff += dsize;
+
+				if ((dyn.d_tag == DT_SUNW_KMOD) &&
+				    (dyn.d_un.d_val == 1)) {
+					EI->kmod = B_TRUE;
+				}
+			}
 		}
 
 		/*
--- old/usr/src/cmd/file/elf_read.h	2019-02-24 19:19:05.363963681 +0000
+++ new/usr/src/cmd/file/elf_read.h	2019-02-24 19:19:05.380330370 +0000
@@ -26,8 +26,6 @@
 #ifndef _ELF_READ_H
 #define	_ELF_READ_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #define	BUFSZ 128
 typedef struct Elf_Info {
 	boolean_t	dynamic;	/* dymanically linked? */
@@ -40,6 +38,7 @@
 	char		fname[PRFNSZ];	/* name of process that dumped core */
 	char		cap_str[BUFSZ];	/* hw/sw capabilities */
 	char		*file;		/* file being processed */
+	boolean_t	kmod;
 } Elf_Info;
 
 /* values for Elf_Info.stripped */
@@ -53,10 +52,14 @@
 #define	EC_NEWCORE	0x2
 
 /* elf file processing errors */
-#define	ELF_ERR_ELFCAP1	gettext("%s: %s zero size or zero entry ELF " \
-			    "section - ELF capabilities ignored\n")
-#define	ELF_ERR_ELFCAP2	gettext("%s: %s: can't read ELF capabilities " \
-			    "data - ELF capabilities ignored\n")
+#define	ELF_ERR_ELFCAP1		gettext("%s: %s zero size or zero entry ELF " \
+	"section - ELF capabilities ignored\n")
+#define	ELF_ERR_ELFCAP2		gettext("%s: %s: can't read ELF capabilities " \
+	"data - ELF capabilities ignored\n")
+#define	ELF_ERR_DYNAMIC1	gettext("%s: %s zero size or zero entry ELF " \
+	"section - ELF dynamic tags ignored\n")
+#define	ELF_ERR_DYNAMIC2	gettext("%s: %s: can't read ELF dynamic " \
+	"data - ELF dynamic tags ignored\n")
 
 extern int is_in_list(char *str);
 
@@ -72,6 +75,7 @@
 #define	Elf_Cap		Elf64_Cap
 #define	Elf_Nhdr	Elf64_Nhdr
 #define	Elf_Word	Elf64_Word
+#define	Elf_Dyn		Elf64_Dyn
 
 #define	elf_read	elf_read64
 #define	elf_xlatetom	elf64_xlatetom
@@ -88,6 +92,7 @@
 #define	Elf_Cap		Elf32_Cap
 #define	Elf_Nhdr	Elf32_Nhdr
 #define	Elf_Word	Elf32_Word
+#define	Elf_Dyn		Elf32_Dyn
 
 #define	elf_read	elf_read32
 #define	elf_xlatetom	elf32_xlatetom
--- old/usr/src/cmd/file/file.c	2019-02-24 19:19:05.787417276 +0000
+++ new/usr/src/cmd/file/file.c	2019-02-24 19:19:05.801762395 +0000
@@ -19,7 +19,7 @@
  * CDDL HEADER END
  */
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
-/*	  All Rights Reserved  	*/
+/*	  All Rights Reserved	*/
 
 
 /*	Copyright (c) 1987, 1988 Microsoft Corporation	*/
@@ -614,7 +614,7 @@
  *	be applied before context-sensitive tests, to avoid
  *	false context-sensitive matches.
  *
- * 	Returns -1 on error which should result in error (non-zero)
+ *	Returns -1 on error which should result in error (non-zero)
  *	exit status for the file utility.
  *	Returns 0 if no matching file type found.
  *	Returns 1 if matching file type found.
@@ -1330,6 +1330,10 @@
 	if (version == 1)
 		(void) printf(" %s %d", gettext("Version"), version);
 
+	if (EInfo.kmod) {
+		(void) printf(", %s", gettext("kernel module"));
+	}
+
 	/* Print Flags */
 	print_elf_flags(EInfo);
 
@@ -1483,9 +1487,10 @@
 	return (1);
 }
 
+/* look for "1hddddd" where d is a digit */
 static int
 sccs(void)
-{				/* look for "1hddddd" where d is a digit */
+{
 	register int j;
 
 	if (fbuf[0] == 1 && fbuf[1] == 'h') {
--- old/usr/src/cmd/sgs/dump/common/dump.c	2019-02-24 19:19:06.292912701 +0000
+++ new/usr/src/cmd/sgs/dump/common/dump.c	2019-02-24 19:19:06.310139344 +0000
@@ -1225,6 +1225,7 @@
 			case DT_SUNW_CAPCHAINENT:
 			case DT_SUNW_CAPCHAINSZ:
 			case DT_SUNW_ASLR:
+			case DT_SUNW_KMOD:
 				(void) printf(pdyn_Fmtptr,
 				    EC_XWORD(p_dyn.d_un.d_val));
 				break;
--- old/usr/src/cmd/sgs/include/_libelf.h	2019-02-24 19:19:06.812800417 +0000
+++ new/usr/src/cmd/sgs/include/_libelf.h	2019-02-24 19:19:06.829550125 +0000
@@ -47,6 +47,7 @@
 extern size_t		_elf_getarsymwordsize(Elf *);
 extern Elf64_Off	_elf_getxoff(Elf_Data *);
 extern GElf_Xword	_gelf_getdyndtflags_1(Elf *);
+extern GElf_Xword	_gelf_getdynval(Elf *, GElf_Sxword);
 extern int		_elf_swap_wrimage(Elf *);
 extern uint_t		_elf_sys_encoding(void);
 
--- old/usr/src/cmd/sgs/include/libld.h	2019-02-24 19:19:07.228505750 +0000
+++ new/usr/src/cmd/sgs/include/libld.h	2019-02-24 19:19:07.244336268 +0000
@@ -105,7 +105,7 @@
  */
 struct rel_cache {
 	APlist		*rc_list;	/* list of Rel_cachebuf */
-	Word		rc_cnt;		/* 	and count */
+	Word		rc_cnt;		/*	and count */
 };
 
 /*
@@ -147,7 +147,7 @@
 	RLXREL_REJ_NONE = 0,	/* Replacement symbol was found */
 	RLXREL_REJ_TARGET,	/* Target sec disallows relaxed relocations */
 	RLXREL_REJ_SECTION,	/* Either there is no replacement section, */
-				/* 	or its attributes are incompatible */
+				/*	or its attributes are incompatible */
 	RLXREL_REJ_SYMBOL,	/* Replacement symbol not found */
 } Rlxrel_rej;
 
@@ -261,15 +261,15 @@
 	APlist		*ofl_ents;	/* list of entrance descriptors */
 	avl_tree_t	ofl_ents_avl;	/* O(log N) access to named ent. desc */
 	APlist		*ofl_objs;	/* relocatable object file list */
-	Word		ofl_objscnt;	/* 	and count */
+	Word		ofl_objscnt;	/*	and count */
 	APlist		*ofl_ars;	/* archive library list */
-	Word		ofl_arscnt;	/* 	and count */
+	Word		ofl_arscnt;	/*	and count */
 	int		ofl_ars_gsandx; /* archive group argv index. 0 means */
 					/*	no current group, < 0 means */
 					/*	error reported. >0 is cur ndx */
 	Word		ofl_ars_gsndx;	/* current -zrescan-start ofl_ars ndx */
 	APlist		*ofl_sos;	/* shared object list */
-	Word		ofl_soscnt;	/* 	and count */
+	Word		ofl_soscnt;	/*	and count */
 	APlist		*ofl_soneed;	/* list of implicitly required .so's */
 	APlist		*ofl_socntl;	/* list of .so control definitions */
 	Rel_cache	ofl_outrels;	/* list of output relocations */
@@ -283,7 +283,7 @@
 	APlist		*ofl_ismove;	/* list of .SUNW_move sections */
 	APlist		*ofl_ismoverel;	/* list of relocation input section */
 					/* targeting to expanded area */
-	APlist		*ofl_parsyms; 	/* list of partially initialized */
+	APlist		*ofl_parsyms;	/* list of partially initialized */
 					/*	symbols (ie. move symbols) */
 	APlist		*ofl_extrarels;	/* relocation sections which have */
 					/*    a NULL sh_info */
@@ -467,6 +467,8 @@
 #define	FLG_OF_FATWARN	0x400000000000	/* make warnings fatal */
 #define	FLG_OF_ADEFLIB	0x800000000000	/* no libraries in default path */
 
+#define	FLG_OF_KMOD	0x1000000000000	/* output is a kernel module */
+
 /*
  * In the flags1 arena, establish any options that are applicable to archive
  * extraction first, and associate a mask.  These values are recorded with any
@@ -536,6 +538,7 @@
 #define	FLG_OFG_NO_MF		0x00000008	/* use v2 mapfile syntax */
 #define	FLG_OFG_NO_TEXT		0x00000010	/* verify pure text segment */
 #define	FLG_OFG_NO_UNUSED	0x00000020	/* remove unused dependency */
+#define	FLG_OFG_NO_KMOD		0x00000040	/* use -z type=kmod */
 
 /*
  * Test to see if a guidance should be given for a given category
@@ -879,7 +882,7 @@
 #define	FLG_IF_DISPPEND 0x00000800	/* displacement relocation done */
 					/*	in the ld time. */
 #define	FLG_IF_DISPDONE 0x00001000	/* displacement relocation done */
-					/* 	at the run time */
+					/*	at the run time */
 #define	FLG_IF_MAPFILE	0x00002000	/* file is a mapfile */
 #define	FLG_IF_HSTRTAB	0x00004000	/* file has a string section */
 #define	FLG_IF_FILEREF	0x00008000	/* file contains a section which */
@@ -916,11 +919,11 @@
 	Elf_Data	*is_indata;	/* input sections raw data */
 	Is_desc		*is_symshndx;	/* related SHT_SYM_SHNDX section */
 	Is_desc		*is_comdatkeep;	/* If COMDAT section is discarded, */
-					/* 	this is section that was kept */
+					/*	this is section that was kept */
 	Word		is_scnndx;	/* original section index in file */
 	Word		is_ordndx;	/* index for section.  Used to decide */
 					/*	where to insert section when */
-					/* 	reordering sections */
+					/*	reordering sections */
 	Word		is_keyident;	/* key for SHF_{ORDERED|LINK_ORDER} */
 					/*	processing and ident used for */
 					/*	 placing/ordering sections */
@@ -990,7 +993,7 @@
 					/*	by section symbol index */
 	Word		os_ordndx;	/* index for section.  Used to decide */
 					/*	where to insert section when */
-					/* 	reordering sections */
+					/*	reordering sections */
 	Xword		os_szoutrels;	/* size of output relocation section */
 	uint_t		os_namehash;	/* hash on section name */
 	uchar_t		os_flags;	/* various flags */
@@ -1067,7 +1070,7 @@
 #define	FLG_SG_P_FLAGS		0x0020	/* p_flags segment attribute set */
 #define	FLG_SG_P_TYPE		0x0040	/* p_type segment attribute set */
 #define	FLG_SG_IS_ORDER		0x0080	/* input section ordering is required */
-					/* 	for this segment. */
+					/*	for this segment. */
 #define	FLG_SG_NOHDR		0x0100	/* don't map ELF or phdrs into */
 					/*	this segment */
 #define	FLG_SG_EMPTY		0x0200	/* an empty segment specification */
@@ -1141,7 +1144,7 @@
 	Move		*md_move;	/* original Move entry */
 	Xword		md_start;	/* start position */
 	Xword		md_len;		/* length of initialization */
-	Word 		md_oidx;	/* output Move entry index */
+	Word		md_oidx;	/* output Move entry index */
 } Mv_desc;
 
 /*
@@ -1172,7 +1175,7 @@
  * important for performance.
  */
 struct sym_aux {
-	APlist 		*sa_dfiles;	/* files where symbol is defined */
+	APlist		*sa_dfiles;	/* files where symbol is defined */
 	Sym		sa_sym;		/* copy of symtab entry */
 	const char	*sa_vfile;	/* first unavailable definition */
 	const char	*sa_rfile;	/* file with first symbol referenced */
@@ -1184,6 +1187,7 @@
 	Half		sa_symspec;	/* special symbol ids */
 	Half		sa_overndx;	/* output file versioning index */
 	Half		sa_dverndx;	/* dependency versioning index */
+	Os_desc		*sa_boundsec;	/* output section of SECBOUND_ syms */
 };
 
 /*
@@ -1200,13 +1204,15 @@
  * These are the ids for processing of `Special symbols'.  They are used
  * to set the sym->sd_aux->sa_symspec field.
  */
-#define	SDAUX_ID_ETEXT	1		/* etext && _etext symbol */
-#define	SDAUX_ID_EDATA	2		/* edata && _edata symbol */
-#define	SDAUX_ID_END	3		/* end, _end, && _END_ symbol */
-#define	SDAUX_ID_DYN	4		/* DYNAMIC && _DYNAMIC symbol */
-#define	SDAUX_ID_PLT	5		/* _PROCEDURE_LINKAGE_TABLE_ symbol */
-#define	SDAUX_ID_GOT	6		/* _GLOBAL_OFFSET_TABLE_ symbol */
-#define	SDAUX_ID_START	7		/* START_ && _START_ symbol */
+#define	SDAUX_ID_ETEXT		1	/* etext && _etext symbol */
+#define	SDAUX_ID_EDATA		2	/* edata && _edata symbol */
+#define	SDAUX_ID_END		3	/* end, _end, && _END_ symbol */
+#define	SDAUX_ID_DYN		4	/* DYNAMIC && _DYNAMIC symbol */
+#define	SDAUX_ID_PLT		5	/* _PROCEDURE_LINKAGE_TABLE_ symbol */
+#define	SDAUX_ID_GOT		6	/* _GLOBAL_OFFSET_TABLE_ symbol */
+#define	SDAUX_ID_START		7	/* START_ && _START_ symbol */
+#define	SDAUX_ID_SECBOUND_START	8	/* __start_<section> symbols */
+#define	SDAUX_ID_SECBOUND_STOP	9	/* __stop_<section> symbols */
 
 /*
  * Flags for sym_desc.sd_flags
@@ -1226,7 +1232,7 @@
 #define	FLG_SY_NOTAVAIL	0x00000020	/* symbol is not available to the */
 					/*	application either because it */
 					/*	originates from an implicitly */
-					/* 	referenced shared object, or */
+					/*	referenced shared object, or */
 					/*	because it is not part of a */
 					/*	specified version. */
 #define	FLG_SY_REDUCED	0x00000040	/* a global is reduced to local */
@@ -1236,7 +1242,7 @@
 #define	FLG_SY_MAPREF	0x00000200	/* symbol reference generated by user */
 					/*	from mapfile */
 #define	FLG_SY_REFRSD	0x00000400	/* symbols sd_ref has been raised */
-					/* 	due to a copy-relocs */
+					/*	due to a copy-relocs */
 					/*	weak-strong pairing */
 #define	FLG_SY_INTPOSE	0x00000800	/* symbol defines an interposer */
 #define	FLG_SY_INVALID	0x00001000	/* unwanted/erroneous symbol */
--- old/usr/src/cmd/sgs/include/sgs.h	2019-02-24 19:19:07.744200219 +0000
+++ new/usr/src/cmd/sgs/include/sgs.h	2019-02-24 19:19:07.759122002 +0000
@@ -194,7 +194,8 @@
 #define	SGS_REJ_PLATCAP		16	/* platform capability mismatch */
 #define	SGS_REJ_HWCAP_2		17	/* hardware capabilities mismatch */
 #define	SGS_REJ_ARCHIVE		18	/* archive used in invalid context */
-#define	SGS_REJ_NUM		19
+#define	SGS_REJ_KMOD		19	/* object is a kernel module */
+#define	SGS_REJ_NUM		20
 
 #define	FLG_REJ_ALTER		0x01	/* object name is an alternative */
 
--- old/usr/src/cmd/sgs/libconv/common/dynamic.c	2019-02-24 19:19:08.163310167 +0000
+++ new/usr/src/cmd/sgs/libconv/common/dynamic.c	2019-02-24 19:19:08.179387770 +0000
@@ -114,7 +114,7 @@
 	MSG_DF_SYMBOLIC_CF_SIZE		+ CONV_EXPN_FIELD_DEF_SEP_SIZE + \
 	MSG_DF_TEXTREL_CF_SIZE		+ CONV_EXPN_FIELD_DEF_SEP_SIZE + \
 	MSG_DF_BIND_NOW_CF_SIZE		+ CONV_EXPN_FIELD_DEF_SEP_SIZE + \
-	MSG_DF_STATIC_TLS_CF_SIZE 	+ CONV_EXPN_FIELD_DEF_SEP_SIZE + \
+	MSG_DF_STATIC_TLS_CF_SIZE	+ CONV_EXPN_FIELD_DEF_SEP_SIZE + \
 	CONV_INV_BUFSIZE + CONV_EXPN_FIELD_DEF_SUFFIX_SIZE
 
 	/*
@@ -557,8 +557,10 @@
 		MSG_DT_SUNW_LDMACH_CF,		0,
 		MSG_DT_SUNW_CAPCHAINENT_CF,	0,
 		MSG_DT_SUNW_CAPCHAINSZ_CF,	0,
-		0, 				0,
-		MSG_DT_SUNW_ASLR_CF
+		0,				0,
+		MSG_DT_SUNW_ASLR_CF,		0,
+		0,				0,
+		MSG_DT_SUNW_KMOD_CF
 	};
 	static const Msg	tags_sunw_auxiliary_cfnp[] = {
 		MSG_DT_SUNW_AUXILIARY_CFNP,	MSG_DT_SUNW_RTLDINF_CFNP,
@@ -572,7 +574,9 @@
 		MSG_DT_SUNW_CAPCHAINENT_CFNP,	0,
 		MSG_DT_SUNW_CAPCHAINSZ_CFNP,	0,
 		0,				0,
-		MSG_DT_SUNW_ASLR_CFNP
+		MSG_DT_SUNW_ASLR_CFNP,		0,
+		0,				0,
+		MSG_DT_SUNW_KMOD_CFNP
 	};
 	static const Msg	tags_sunw_auxiliary_nf[] = {
 		MSG_DT_SUNW_AUXILIARY_NF,	MSG_DT_SUNW_RTLDINF_NF,
@@ -586,7 +590,9 @@
 		MSG_DT_SUNW_CAPCHAINENT_NF,	0,
 		MSG_DT_SUNW_CAPCHAINSZ_NF,	0,
 		0,				0,
-		MSG_DT_SUNW_ASLR_NF
+		MSG_DT_SUNW_ASLR_NF,		0,
+		0,				0,
+		MSG_DT_SUNW_KMOD_NF
 	};
 	static const conv_ds_msg_t ds_sunw_auxiliary_cf = {
 	    CONV_DS_MSG_INIT(DT_SUNW_AUXILIARY, tags_sunw_auxiliary_cf) };
--- old/usr/src/cmd/sgs/libconv/common/dynamic.msg	2019-02-24 19:19:08.628701773 +0000
+++ new/usr/src/cmd/sgs/libconv/common/dynamic.msg	2019-02-24 19:19:08.644724302 +0000
@@ -175,12 +175,15 @@
 @ MSG_DT_SUNW_CAPCHAINENT_CF	"DT_SUNW_CAPCHAINENT"		# 0x6000001d
 @ MSG_DT_SUNW_CAPCHAINENT_CFNP		"SUNW_CAPCHAINENT"
 @ MSG_DT_SUNW_CAPCHAINENT_NF		"sunw_capchainent"
-@ MSG_DT_SUNW_CAPCHAINSZ_CF	"DT_SUNW_CAPCHAINSZ"		# 0x6000001d
+@ MSG_DT_SUNW_CAPCHAINSZ_CF	"DT_SUNW_CAPCHAINSZ"		# 0x6000001f
 @ MSG_DT_SUNW_CAPCHAINSZ_CFNP		"SUNW_CAPCHAINSZ"
 @ MSG_DT_SUNW_CAPCHAINSZ_NF		"sunw_capchainsz"
 @ MSG_DT_SUNW_ASLR_CF		"DT_SUNW_ASLR"			# 0x60000023
 @ MSG_DT_SUNW_ASLR_CFNP			"SUNW_ASLR"
 @ MSG_DT_SUNW_ASLR_NF			"sunw_aslr"
+@ MSG_DT_SUNW_KMOD_CF		"DT_SUNW_KMOD"			# 0x60000027
+@ MSG_DT_SUNW_KMOD_CFNP			"SUNW_KMOD"
+@ MSG_DT_SUNW_KMOD_NF			"sunw_kmod"
 
 @ MSG_DT_GNU_PRELINKED_CF	"DT_GNU_PRELINKED"		# 0x6ffffdf5
 @ MSG_DT_GNU_PRELINKED_CFNP		"GNU_PRELINKED"
--- old/usr/src/cmd/sgs/libconv/common/elf.c	2019-02-24 19:19:09.081600028 +0000
+++ new/usr/src/cmd/sgs/libconv/common/elf.c	2019-02-24 19:19:09.097079304 +0000
@@ -1211,6 +1211,7 @@
 		    &reject_desc_buf->flags_buf));
 	case SGS_REJ_UNKFILE:
 	case SGS_REJ_ARCHIVE:
+	case SGS_REJ_KMOD:
 		return (NULL);
 	case SGS_REJ_STR:
 	case SGS_REJ_HWCAP_1:
--- old/usr/src/cmd/sgs/libelf/common/gelf.c	2019-02-24 19:19:09.560570058 +0000
+++ new/usr/src/cmd/sgs/libelf/common/gelf.c	2019-02-24 19:19:09.575587223 +0000
@@ -698,7 +698,7 @@
 
 GElf_Sym *
 gelf_getsymshndx(Elf_Data *symdata, Elf_Data *shndxdata,
-	int ndx, GElf_Sym *symptr, Elf32_Word *xshndx)
+    int ndx, GElf_Sym *symptr, Elf32_Word *xshndx)
 {
 	if (gelf_getsym(symdata, ndx, symptr) == 0)
 		return (NULL);
@@ -719,7 +719,7 @@
 
 int
 gelf_update_symshndx(Elf_Data *symdata, Elf_Data *shndxdata,
-	int ndx, GElf_Sym *symptr, Elf32_Word xshndx)
+    int ndx, GElf_Sym *symptr, Elf32_Word xshndx)
 {
 	if (gelf_update_sym(symdata, ndx, symptr) == 0)
 		return (0);
@@ -1091,7 +1091,7 @@
  * Otherwise, return 0.
  */
 GElf_Xword
-_gelf_getdyndtflags_1(Elf *elf)
+_gelf_getdynval(Elf *elf, GElf_Sxword tag)
 {
 	Elf_Scn *scn = NULL;
 	Elf_Data *data;
@@ -1108,7 +1108,7 @@
 			n = shdr.sh_size / shdr.sh_entsize;
 			for (i = 0; i < n; i++) {
 				(void) gelf_getdyn(data, i, &dyn);
-				if (dyn.d_tag == DT_FLAGS_1) {
+				if (dyn.d_tag == tag) {
 					return (dyn.d_un.d_val);
 				}
 			}
@@ -1117,3 +1117,9 @@
 	}
 	return (0);
 }
+
+GElf_Xword
+_gelf_getdyndtflags_1(Elf *elf)
+{
+	return (_gelf_getdynval(elf, DT_FLAGS_1));
+}
--- old/usr/src/cmd/sgs/libelf/common/mapfile-vers	2019-02-24 19:19:10.009609024 +0000
+++ new/usr/src/cmd/sgs/libelf/common/mapfile-vers	2019-02-24 19:19:10.025091909 +0000
@@ -170,6 +170,7 @@
 	_elf_sys_encoding;
 	_elf_swap_wrimage;
 	_gelf_getdyndtflags_1;
+	_gelf_getdynval;
 
 $if _ELF32
 	elf_demangle;
--- old/usr/src/cmd/sgs/libld/common/args.c	2019-02-24 19:19:10.443450828 +0000
+++ new/usr/src/cmd/sgs/libld/common/args.c	2019-02-24 19:19:10.459065182 +0000
@@ -37,7 +37,7 @@
  *    OPTION			MEANING
  *
  *    -z dtrace=symbol		assigns symbol to PT_SUNWDTRACE segment,
- *    				providing scratch area for dtrace processing.
+ *				providing scratch area for dtrace processing.
  *
  *    -z noreloc		suppress relocation processing.  This provides
  *				a mechanism for validating kernel module symbol
@@ -103,7 +103,6 @@
 
 static Boolean	aflag	= FALSE;
 static Boolean	bflag	= FALSE;
-static Boolean	rflag	= FALSE;
 static Boolean	sflag	= FALSE;
 static Boolean	zinflag = FALSE;
 static Boolean	zlflag	= FALSE;
@@ -112,9 +111,17 @@
 static Boolean	Beflag	= FALSE;
 static Boolean	Bsflag	= FALSE;
 static Boolean	Dflag	= FALSE;
-static Boolean	Gflag	= FALSE;
 static Boolean	Vflag	= FALSE;
 
+enum output_type {
+	OT_RELOC,		/* relocatable object */
+	OT_SHARED,		/* shared object */
+	OT_EXEC,		/* dynamic executable */
+	OT_KMOD,		/* kernel module */
+};
+
+static enum output_type	otype = OT_EXEC;
+
 /*
  * ztflag's state is set by pointing it to the matching string:
  *	text | textoff | textwarn
@@ -228,6 +235,7 @@
 	(void) fprintf(stderr, MSG_INTL(MSG_ARG_DETAIL_ZT));
 	(void) fprintf(stderr, MSG_INTL(MSG_ARG_DETAIL_ZTO));
 	(void) fprintf(stderr, MSG_INTL(MSG_ARG_DETAIL_ZTW));
+	(void) fprintf(stderr, MSG_INTL(MSG_ARG_DETAIL_ZTY));
 	(void) fprintf(stderr, MSG_INTL(MSG_ARG_DETAIL_ZWRAP));
 	(void) fprintf(stderr, MSG_INTL(MSG_ARG_DETAIL_ZVER));
 }
@@ -313,18 +321,46 @@
 		ld_eprintf(ofl, ERR_FATAL, MSG_INTL(MSG_ARG_YP),
 		    Llibdir ? 'L' : 'U');
 
-	if (rflag) {
-		if (dflag == SET_UNKNOWN)
-			dflag = SET_FALSE;
+	if ((otype == OT_RELOC) || (otype == OT_KMOD)) {
+		if (otype == OT_RELOC) {
+			if (dflag == SET_UNKNOWN)
+				dflag = SET_FALSE;
+			if ((dflag == SET_TRUE) &&
+			    OFL_GUIDANCE(ofl, FLG_OFG_NO_KMOD)) {
+				ld_eprintf(ofl, ERR_GUIDANCE,
+				    MSG_INTL(MSG_GUIDE_KMOD));
+			}
+		} else if (otype == OT_KMOD) {
+			if (dflag != SET_UNKNOWN) {
+				ld_eprintf(ofl, ERR_FATAL,
+				    MSG_INTL(MSG_MARG_INCOMP),
+				    MSG_INTL(MSG_MARG_TYPE_KMOD),
+				    MSG_ORIG(MSG_ARG_D));
+			}
+
+			dflag = SET_TRUE;
+		}
+
 		/*
 		 * Combining relocations when building a relocatable
 		 * object isn't allowed.  Warn the user, but proceed.
 		 */
-		if (ofl->ofl_flags & FLG_OF_COMREL)
+		if (ofl->ofl_flags & FLG_OF_COMREL) {
+			const char *msg;
+
+			if (otype == OT_RELOC) {
+				msg = MSG_INTL(MSG_MARG_REL);
+			} else {
+				msg = MSG_INTL(MSG_MARG_TYPE_KMOD);
+			}
 			ld_eprintf(ofl, ERR_WARNING, MSG_INTL(MSG_MARG_INCOMP),
-			    MSG_INTL(MSG_MARG_REL),
+			    msg,
 			    MSG_ORIG(MSG_ARG_ZCOMBRELOC));
+		}
 		ofl->ofl_flags |= FLG_OF_RELOBJ;
+
+		if (otype == OT_KMOD)
+			ofl->ofl_flags |= FLG_OF_KMOD;
 	} else {
 		/*
 		 * Translating object capabilities to symbol capabilities is
@@ -375,7 +411,7 @@
 		    MSG_ORIG(MSG_ARG_ZRELAXRELOC),
 		    MSG_ORIG(MSG_ARG_ZNORELAXRELOC));
 
-	if (ofl->ofl_filtees && !Gflag)
+	if (ofl->ofl_filtees && (otype != OT_SHARED))
 		ld_eprintf(ofl, ERR_FATAL, MSG_INTL(MSG_MARG_ST_ONLYAVL),
 		    ((ofl->ofl_flags & FLG_OF_AUX) ?
 		    MSG_INTL(MSG_MARG_FILTER_AUX) : MSG_INTL(MSG_MARG_FILTER)));
@@ -429,7 +465,7 @@
 			ofl->ofl_guideflags |= FLG_OFG_NO_TEXT;
 		}
 
-		if (Gflag || !rflag) {
+		if ((otype == OT_SHARED) || (otype == OT_EXEC)) {
 			/*
 			 * Create a dynamic object.  -Bdirect indicates that all
 			 * references should be bound directly.  This also
@@ -469,7 +505,7 @@
 			}
 		}
 
-		if (!Gflag && !rflag) {
+		if (otype == OT_EXEC) {
 			/*
 			 * Dynamically linked executable.
 			 */
@@ -493,7 +529,7 @@
 				ld_eprintf(ofl, ERR_FATAL,
 				    MSG_INTL(MSG_MARG_DY_INCOMP),
 				    MSG_INTL(MSG_MARG_SONAME));
-		} else if (!rflag) {
+		} else if (otype == OT_SHARED) {
 			/*
 			 * Shared library.
 			 */
@@ -543,6 +579,9 @@
 				    MSG_INTL(MSG_MARG_REL),
 				    MSG_ORIG(MSG_ARG_CI));
 		}
+
+		assert((ofl->ofl_flags & (FLG_OF_SHAROBJ|FLG_OF_EXEC)) !=
+		    (FLG_OF_SHAROBJ|FLG_OF_EXEC));
 	} else {
 		ofl->ofl_flags |= FLG_OF_STATIC;
 
@@ -564,14 +603,14 @@
 		if (ztflag)
 			ld_eprintf(ofl, ERR_FATAL, MSG_INTL(MSG_ARG_ST_INCOMP),
 			    MSG_ORIG(MSG_ARG_ZTEXTALL));
-		if (Gflag)
+		if (otype == OT_SHARED)
 			ld_eprintf(ofl, ERR_FATAL, MSG_INTL(MSG_MARG_ST_INCOMP),
 			    MSG_INTL(MSG_MARG_SO));
-		if (aflag && rflag)
+		if (aflag && (otype == OT_RELOC))
 			ld_eprintf(ofl, ERR_FATAL, MSG_INTL(MSG_MARG_INCOMP),
 			    MSG_ORIG(MSG_ARG_A), MSG_INTL(MSG_MARG_REL));
 
-		if (rflag) {
+		if (otype == OT_RELOC) {
 			/*
 			 * We can only strip the symbol table and string table
 			 * if no output relocations will refer to them.
@@ -717,7 +756,7 @@
 
 	/*
 	 * The argument being examined is either:
-	 *	ld32= 	or
+	 *	ld32=	or
 	 *	ld64=
 	 */
 #if	defined(_LP64)
@@ -917,8 +956,8 @@
 /*
  * Parse the -z assert-deflib option. This option can appear in two different
  * forms:
- * 	-z assert-deflib
- * 	-z assert-deflib=libfred.so
+ *	-z assert-deflib
+ *	-z assert-deflib=libfred.so
  *
  * Either form enables this option, the latter form marks libfred.so as an
  * exempt library from the check. It is valid to have multiple invocations of
@@ -1201,7 +1240,7 @@
 
 		case 'r':
 			DBG_CALL(Dbg_args_option(ofl->ofl_lml, ndx, c, NULL));
-			rflag = TRUE;
+			otype = OT_RELOC;
 			break;
 
 		case 'R':
@@ -1509,6 +1548,35 @@
 			    MSG_ARG_ASSDEFLIB_SIZE) == 0) {
 				if (assdeflib_parse(ofl, optarg) != TRUE)
 					return (S_ERROR);
+			} else if (strncmp(optarg, MSG_ORIG(MSG_ARG_TYPE),
+			    MSG_ARG_TYPE_SIZE) == 0) {
+				char *p = optarg + MSG_ARG_TYPE_SIZE;
+				if (*p != '=') {
+					ld_eprintf(ofl, ERR_FATAL,
+					    MSG_INTL(MSG_ARG_ILLEGAL),
+					    MSG_ORIG(MSG_ARG_Z), optarg);
+					return (S_ERROR);
+				}
+
+				p++;
+				if (strcmp(p,
+				    MSG_ORIG(MSG_ARG_TYPE_RELOC)) == 0) {
+					otype = OT_RELOC;
+				} else if (strcmp(p,
+				    MSG_ORIG(MSG_ARG_TYPE_EXEC)) == 0) {
+					otype = OT_EXEC;
+				} else if (strcmp(p,
+				    MSG_ORIG(MSG_ARG_TYPE_SHARED)) == 0) {
+					otype = OT_SHARED;
+				} else if (strcmp(p,
+				    MSG_ORIG(MSG_ARG_TYPE_KMOD)) == 0) {
+					otype = OT_KMOD;
+				} else {
+					ld_eprintf(ofl, ERR_FATAL,
+					    MSG_INTL(MSG_ARG_ILLEGAL),
+					    MSG_ORIG(MSG_ARG_Z), optarg);
+					return (S_ERROR);
+				}
 			/*
 			 * The following options just need validation as they
 			 * are interpreted on the second pass through the
@@ -1627,7 +1695,7 @@
 
 		case 'G':
 			DBG_CALL(Dbg_args_option(ofl->ofl_lml, ndx, c, NULL));
-			Gflag = TRUE;
+			otype = OT_SHARED;
 			break;
 
 		case 'L':
--- old/usr/src/cmd/sgs/libld/common/files.c	2019-02-24 19:19:10.996040781 +0000
+++ new/usr/src/cmd/sgs/libld/common/files.c	2019-02-24 19:19:11.011657862 +0000
@@ -2356,7 +2356,7 @@
 static uintptr_t
 rel_process(Is_desc *isc, Ifl_desc *ifl, Ofl_desc *ofl)
 {
-	Word 	rndx;
+	Word	rndx;
 	Is_desc	*risc;
 	Os_desc	*osp;
 	Shdr	*shdr = isc->is_shdr;
@@ -3193,6 +3193,20 @@
 			if (rej->rej_type == 0) {
 				*rej = _rej;
 				rej->rej_name = strdup(_rej.rej_name);
+			}
+			return (0);
+		}
+
+		if (_gelf_getdynval(elf, DT_SUNW_KMOD) == 1) {
+			_rej.rej_name = name;
+			DBG_CALL(Dbg_file_rejected(ofl->ofl_lml, &_rej,
+			    ld_targ.t_m.m_mach));
+			_rej.rej_type = SGS_REJ_KMOD;
+			_rej.rej_str = elf_errmsg(-1);
+
+			if (rej->rej_type == 0) {
+				*rej = _rej;
+				rej->rej_name = strdup(_rej.rej_name);
 			}
 			return (0);
 		}
--- old/usr/src/cmd/sgs/libld/common/globals.c	2019-02-24 19:19:11.563549030 +0000
+++ new/usr/src/cmd/sgs/libld/common/globals.c	2019-02-24 19:19:11.578204633 +0000
@@ -34,7 +34,7 @@
 #include	"_libld.h"
 
 Ld_heap		*ld_heap;	/* list of allocated blocks for */
-				/* 	link-edit dynamic allocations */
+				/*	link-edit dynamic allocations */
 APlist		*lib_support;	/* list of support libraries specified */
 				/*	(-S option) */
 int		demangle_flag;	/* symbol demangling required */
@@ -78,9 +78,10 @@
 		MSG_REJ_MACHCAP,	/* MSG_INTL(MSG_REJ_MACHCAP) */
 		MSG_REJ_PLATCAP,	/* MSG_INTL(MSG_REJ_PLATCAP) */
 		MSG_REJ_HWCAP_2,	/* MSG_INTL(MSG_REJ_HWCAP_2) */
-		MSG_REJ_ARCHIVE		/* MSG_INTL(MSG_REJ_ARCHIVE) */
+		MSG_REJ_ARCHIVE,	/* MSG_INTL(MSG_REJ_ARCHIVE) */
+		MSG_REJ_KMOD		/* MSG_INTL(MSG_REJ_KMOD) */
 	};
-#if SGS_REJ_NUM != (SGS_REJ_ARCHIVE + 1)
+#if SGS_REJ_NUM != (SGS_REJ_KMOD + 1)
 #error SGS_REJ_NUM has changed
 #endif
 
